import CiaoApp.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

class CiaoCallbackServant extends _CiaoCallbackImplBase
{
    public void callback(String notification)
    {
	System.out.println(notification);
    }
}

public class CiaoClient {

    public static void main(String args[])
    {
     try{
	ORB orb = ORB.init(args, null);

	org.omg.CORBA.Object objRef =                 
                       orb.resolve_initial_references("NameService");
        NamingContext ncRef = NamingContextHelper.narrow(objRef);
        NameComponent nc = new NameComponent("Ciao", "");
        NameComponent path[] = {nc};
        Ciao ciaoRef = CiaoHelper.narrow(ncRef.resolve(path));

	CiaoCallbackServant ciaoCallbackRef = new CiaoCallbackServant();
        orb.connect(ciaoCallbackRef);

	// call the ciao server object and print results
	String ciao = ciaoRef.sayCiao(ciaoCallbackRef, "\n Buongiorno\n");
	System.out.println(ciao);

        }catch(Exception e) {
            System.err.println("ERROR : " + e);
            e.printStackTrace(System.out);
        }
    }
}    
