import HelloApp.*;          // The package containing our stubs.
import org.omg.CosNaming.*; // HelloServer will use the naming service.
import org.omg.CosNaming.NamingContextPackage.*; // ..for exceptions.
import org.omg.CORBA.*;     // All CORBA applications need these classes.

public class HelloServer
{
    public static void main(String args[])
    {
	try {
	    ORB orb = ORB.init(args, null);
	    HelloServant helloRef = new HelloServant();
	    orb.connect(helloRef);
	    org.omg.CORBA.Object objRef = 
		           orb.resolve_initial_references("NameService");
	    NamingContext ncRef = NamingContextHelper.narrow(objRef);
	    NameComponent nc = new NameComponent("Hello", "");
	    NameComponent path[] = {nc};
	    ncRef.rebind(path, helloRef);
	    java.lang.Object sync = new java.lang.Object();
	    synchronized(sync) {
		sync.wait();
	    }
	    
	}catch(Exception e) {
	    System.err.println("ERROR : " + e);
	    e.printStackTrace(System.out);
	}
    }
}

//class HelloServant extends _HelloImplBase
//{
//    public String sayHello()
//    {
//	return "\nHello world!!\n";
//    }
//}
