import SecretApp.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import java.io.*;
 
class SecretServant extends _SecretImplBase
{
    public String saveSecret(String msg)
        throws SecretApp.SecretPackage.cantWriteFile
    {
        try {
                synchronized(this) {
                   File secretFile = new File("secretStorage.txt");
                   FileOutputStream fos = new FileOutputStream(secretFile);
                   byte[] buf = new byte[msg.length()];
                   msg.getBytes(0, msg.length(), buf, 0);
                   fos.write(buf);
                   fos.close();
                }
        } catch(Exception e) {
                throw new SecretApp.SecretPackage.cantWriteFile();
        }
        return "\n Your secret is safe with me... \n";
    }
       
    public String lastSecret()
        throws SecretApp.SecretPackage.cantReadFile
    {
        try {
                synchronized(this) {
                   File secretFile = new File("secretStorage.txt");
                   FileInputStream fis = new FileInputStream(secretFile);
                   byte[] buf = new byte[1000];
                   int n = fis.read(buf);
                   String lastmsg = new String(buf);
                   fis.close();
                   return lastmsg;
                }
        } catch(Exception e) {
                throw new SecretApp.SecretPackage.cantReadFile();
        }    }
}

 
public class SecretServer {
 
    public static void main(String args[])
    {
        try{
            // create and initialize the ORB
            ORB orb = ORB.init(args, null);
 
            // create servant and register it with the ORB
            SecretServant secretRef = new SecretServant();
            orb.connect(secretRef);
 
            // get the root naming context
            org.omg.CORBA.Object objRef = 
                orb.resolve_initial_references("NameService");
            NamingContext ncRef = NamingContextHelper.narrow(objRef);
 
            // bind the Object Reference in Naming
            NameComponent nc = new NameComponent("Secret", "");
            NameComponent path[] = {nc};
            ncRef.rebind(path, secretRef);
 
            // wait for invocations from clients
            java.lang.Object sync = new java.lang.Object();
            synchronized (sync) {
                sync.wait();
            }
 
        } catch (Exception e) {
            System.err.println("ERROR: " + e);
            e.printStackTrace(System.out);
        }
    }
}
 
